<?php
//
// Google Map Component
// Copyright (c) 2008-2016 Nagios Enterprises, LLC. All rights reserved.
//

require_once(dirname(__FILE__) . '/../componenthelper.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();


// route request
route_request();


function route_request()
{
    global $request;

    show_page();

    exit;
}


function show_page($error = false, $msg = "")
{
    global $request;
    global $lstr;


    do_page_start(array("page_title" => "Google Map"), true);


    function display_default_form()
    {
        $coords = get_user_meta($_SESSION["user_id"], 'googlemap_coords', get_option('googlemap_coords', '37.09024, -95.71289'));

        if (isset($coords)) {

            $defCoords = $coords;
            $zoom = get_user_meta($_SESSION["user_id"], 'googlemap_zoom', get_option('googlemap_zoom', 5));
            $refresh = get_user_meta($_SESSION["user_id"], 'googlemap_refresh', 30);
            $linecolor = get_user_meta($_SESSION["user_id"], 'googlemap_linecolor', '#ee1212');
        } else {

            $defCoords = '39.100226,-94.575806';
            $zoom = 1;
            $refresh = 30;
            $linecolor = '#ee1212';
        }
        
        $dc = htmlentities($defCoords); //security fixes
        $s = urlencode('set_map_defaults.php');
        $z = htmlentities($zoom);
        $r = htmlentities($refresh);
        $lc = htmlentities($linecolor);

        $default_form = "
	
	<h3>" . _("Please set your default coordinates and zoom level.") . "</h3>
	<form id='googlemap_defaults' method='post' action='{$s}'>

		<label for='latlng'>" . _("Default Center Coordinates") . ": (" . _("Latitude/Longitude") . ") </label><br />
		<input type='text' name='latlng' id='latlng' value='{$dc}' /><br /><br />

		<label for='zoom'>" . _("Default Zoom Level") . ": (" . _("Recommended") . " 7-20)</label><br />
		<input type='text' name='zoom' id='zoom' value='{$z}' /><br /><br />

        <label for='refresh'>" . _("Refresh Rate") . ": (" . _("in seconds") . ")</label><br />
        <input type='text' name='refresh' id='refresh' value='{$r}' /><br /><br />

        <label for='linecolor'>" . _("Host to Parent Line Color") . ":</label><br />
        <input type='text' name='linecolor' id='linecolor' value='{$lc}' /><br /><br />

		<input type='submit' name='submit' id='submit' value='" . _("Submit") . "' />

		<input type='hidden' name='submitted' id='submitted' value='true' />
	
	</form>";

        print $default_form;
    }

    if (isset($_POST['submitted'])) {
        if (isset($_POST['latlng'], $_POST['zoom'], $_POST['refresh'])) {

            $defRefresh = htmlentities($_POST['refresh']);
            $defZoom = htmlentities($_POST['zoom']);
            $defCoords = htmlentities($_POST['latlng']);
            $defLineColor = htmlentities($_POST['linecolor']);

            if (!is_numeric($defZoom)) $defZoom = 1;
            if (!is_numeric($defRefresh)) $defRefresh = 30;
            
            set_user_meta(0, 'googlemap_coords', $defCoords);
            set_user_meta(0, 'googlemap_zoom', $defZoom);
            set_user_meta(0, 'googlemap_refresh', $defRefresh);
            set_user_meta(0, 'googlemap_linecolor', $defLineColor);

            print '<p>' . _('Default values set!') . '  <a href="map.php">' . _('Return to Google Map') . '</a></p><br /><br />';
        }
    }
    
    display_default_form();

    do_page_end(true);
    exit();
}


?>